VERSION 5.00
Begin VB.Form frmPDU 
   BorderStyle     =   1  'Fest Einfach
   Caption         =   "PDU Encoder for SMS"
   ClientHeight    =   6960
   ClientLeft      =   45
   ClientTop       =   435
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   ScaleHeight     =   6960
   ScaleWidth      =   4680
   StartUpPosition =   3  'Windows-Standard
   Begin VB.CheckBox chkIncludeSMSC 
      Caption         =   "Include SMSC Address:"
      Height          =   255
      Left            =   120
      TabIndex        =   14
      Top             =   180
      Width           =   2055
   End
   Begin VB.TextBox txtCmds 
      Height          =   1455
      Left            =   120
      Locked          =   -1  'True
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertikal
      TabIndex        =   8
      Top             =   4800
      Width           =   4455
   End
   Begin VB.CommandButton cmdCopyCmds 
      Caption         =   "&Copy"
      Height          =   375
      Left            =   3360
      TabIndex        =   9
      Top             =   6360
      Width           =   1215
   End
   Begin VB.CommandButton cmdCopy 
      Caption         =   "&Copy"
      Height          =   375
      Left            =   3360
      TabIndex        =   6
      Top             =   4200
      Width           =   1215
   End
   Begin VB.TextBox txtPDU 
      Height          =   975
      Left            =   120
      Locked          =   -1  'True
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertikal
      TabIndex        =   5
      Top             =   3120
      Width           =   4455
   End
   Begin VB.CommandButton btnEncode 
      Caption         =   "Encode PDU"
      Default         =   -1  'True
      Height          =   375
      Left            =   120
      TabIndex        =   4
      Top             =   2520
      Width           =   1215
   End
   Begin VB.CheckBox chkSMSCFromDevice 
      Caption         =   "Get from device"
      Height          =   375
      Left            =   2280
      TabIndex        =   11
      Top             =   480
      Width           =   2295
   End
   Begin VB.TextBox txtDestAddr 
      Height          =   375
      Left            =   120
      MaxLength       =   30
      TabIndex        =   1
      Top             =   1200
      Width           =   2055
   End
   Begin VB.TextBox txtUserData 
      Height          =   375
      Left            =   120
      MaxLength       =   160
      TabIndex        =   3
      Text            =   "This is a test message. {Euro:}"
      Top             =   1920
      Width           =   4335
   End
   Begin VB.TextBox txtSMSCAddr 
      Height          =   375
      Left            =   120
      MaxLength       =   30
      TabIndex        =   10
      Top             =   480
      Width           =   2055
   End
   Begin VB.Label lblNote 
      Caption         =   "Note: Insert this into your terminal programm and then press <CTRL+Z> to send it."
      Height          =   495
      Left            =   120
      TabIndex        =   13
      Top             =   6360
      Width           =   3135
   End
   Begin VB.Label lblSerialCommands 
      Caption         =   "Serial commands:"
      Height          =   255
      Left            =   120
      TabIndex        =   7
      Top             =   4560
      Width           =   4455
   End
   Begin VB.Label lblActualLength 
      Height          =   375
      Left            =   120
      TabIndex        =   12
      Top             =   4200
      Width           =   3135
   End
   Begin VB.Label Label3 
      Caption         =   "User Data: (Message, 160 characters maximum)"
      Height          =   255
      Left            =   120
      TabIndex        =   2
      Top             =   1680
      Width           =   4335
   End
   Begin VB.Label Label2 
      Caption         =   "Destination Address (Phone number):"
      Height          =   255
      Left            =   120
      TabIndex        =   0
      Top             =   960
      Width           =   4455
   End
End
Attribute VB_Name = "frmPDU"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Function EncodePDU(ByRef intActualPDULength As Integer) As String
    Dim strEncoded As String
    
    Dim encoder As PDU
    Set encoder = New PDU
    strEncoded = encoder.EncodePDU(txtUserData.Text, txtDestAddr.Text, _
        IIf(chkSMSCFromDevice.Value = vbChecked, "", txtSMSCAddr.Text), _
        intActualPDULength, chkIncludeSMSC.Value = vbChecked)
    Set encoder = Nothing
        
    EncodePDU = strEncoded
End Function

Private Sub btnEncode_Click()
    Dim strEncoded As String
    Dim intActualPDULength As Integer
    strEncoded = EncodePDU(intActualPDULength)
    txtPDU.Text = strEncoded
    lblActualLength.Caption = "Actual PDU length: " & CStr(intActualPDULength)
    txtCmds.Text = ""
    txtCmds.Text = "AT+CMGF=0" & vbCrLf & "AT+CMGS=" & CStr(intActualPDULength) & vbCrLf & strEncoded
End Sub

Private Sub chkSMSCFromDevice_Click()
    If chkSMSCFromDevice.Value = vbChecked Then
        txtSMSCAddr.Enabled = False
    Else
        txtSMSCAddr.Enabled = True
        txtSMSCAddr.SetFocus
    End If
End Sub

Private Sub cmdCopy_Click()
    If txtPDU.Text <> "" Then
        Clipboard.Clear
        Call Clipboard.SetText(txtPDU.Text)
    End If
End Sub

Private Sub cmdCopyCmds_Click()
    If txtCmds.Text <> "" Then
        Clipboard.Clear
        Call Clipboard.SetText(txtCmds.Text)
    End If
End Sub

Private Sub Form_Load()
    chkIncludeSMSC.Value = vbChecked
    chkSMSCFromDevice.Value = vbChecked
End Sub
